searchNodes=[{"type":"module","title":"RabbitMQStream","doc":"Responsible for managing multiple connections for a single cluster, routing requests accordingly, and enforcing Well-behaved praticies.","ref":"RabbitMQStream.html"},{"type":"module","title":"RabbitMQStream.OsirisChunk","doc":"Struct that holds the data of a Osiris chunk, which is the format used by RabbitMQ Stream to store the stream data. You can find more information at their Github repo","ref":"RabbitMQStream.OsirisChunk.html"},{"type":"type","title":"RabbitMQStream.OsirisChunk.chunk_type/0","doc":"","ref":"RabbitMQStream.OsirisChunk.html#t:chunk_type/0"},{"type":"type","title":"RabbitMQStream.OsirisChunk.t/0","doc":"","ref":"RabbitMQStream.OsirisChunk.html#t:t/0"},{"type":"behaviour","title":"RabbitMQStream.Connection","doc":"Responsible for encoding and decoding messages, opening and maintaining a socket connection to a single node. It connects to the RabbitMQ, and authenticates, and mantains the connection open with heartbeats. Adding a connectiong to the supervision tree You can define a connection with: defmodule MyApp.MyConnection use RabbitMQStream.Connection end Then you can add it to your supervision tree: def start ( _ , _ ) do children = [ { MyApp.MyConnection , username : &quot;guest&quot; , password : &quot;guest&quot; , host : &quot;localhost&quot; , vhost : &quot;/&quot; } , # ... ] opts = # ... Supervisor . start_link ( children , opts ) end Connection configuration The connection accept the following options: username - The username to use for authentication. Defaults to guest . password - The password to use for authentication. Defaults to guest . host - The host to connect to. Defaults to localhost . port - The port to connect to. Defaults to 5552 . vhost - The virtual host to use. Defaults to / . frame_max - The maximum frame size in Bytes. Defaults to 1_048_576 . heartbeat - The heartbeat interval in seconds. Defaults to 60 . lazy - If true , the connection won't starting until explicitly calling connect/1 . Defaults to false . Subscribing to messages You can subscribe to messages by calling subscribe/5 : { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 ) Configuration The configuration for the connection can be set in your config.exs file: config :rabbitmq_stream , MyApp.MyConnection , username : &quot;guest&quot; , password : &quot;guest&quot; # ... You can override each configuration option by manually passing each configuration on the use macro: defmodule MyApp.MyConnection use RabbitMQStream.Connection , username : &quot;guest&quot; , password : &quot;guest&quot; end or when adding to the supervision tree: def start ( _ , _ ) do children = [ { MyApp.MyConnection , username : &quot;guest&quot; , password : &quot;guest&quot; } , # ... ] opts = # ... Supervisor . start_link ( children , opts ) end The precedence order is is the same order as the examples above, from top to bottom.","ref":"RabbitMQStream.Connection.html"},{"type":"callback","title":"RabbitMQStream.Connection.close/2","doc":"","ref":"RabbitMQStream.Connection.html#c:close/2"},{"type":"callback","title":"RabbitMQStream.Connection.connect/0","doc":"","ref":"RabbitMQStream.Connection.html#c:connect/0"},{"type":"callback","title":"RabbitMQStream.Connection.create_stream/2","doc":"","ref":"RabbitMQStream.Connection.html#c:create_stream/2"},{"type":"callback","title":"RabbitMQStream.Connection.declare_publisher/2","doc":"","ref":"RabbitMQStream.Connection.html#c:declare_publisher/2"},{"type":"callback","title":"RabbitMQStream.Connection.delete_publisher/1","doc":"","ref":"RabbitMQStream.Connection.html#c:delete_publisher/1"},{"type":"callback","title":"RabbitMQStream.Connection.delete_stream/1","doc":"","ref":"RabbitMQStream.Connection.html#c:delete_stream/1"},{"type":"callback","title":"RabbitMQStream.Connection.publish/3","doc":"","ref":"RabbitMQStream.Connection.html#c:publish/3"},{"type":"callback","title":"RabbitMQStream.Connection.query_metadata/1","doc":"","ref":"RabbitMQStream.Connection.html#c:query_metadata/1"},{"type":"callback","title":"RabbitMQStream.Connection.query_offset/2","doc":"","ref":"RabbitMQStream.Connection.html#c:query_offset/2"},{"type":"callback","title":"RabbitMQStream.Connection.query_publisher_sequence/2","doc":"","ref":"RabbitMQStream.Connection.html#c:query_publisher_sequence/2"},{"type":"callback","title":"RabbitMQStream.Connection.start_link/1","doc":"","ref":"RabbitMQStream.Connection.html#c:start_link/1"},{"type":"callback","title":"RabbitMQStream.Connection.store_offset/3","doc":"","ref":"RabbitMQStream.Connection.html#c:store_offset/3"},{"type":"callback","title":"RabbitMQStream.Connection.subscribe/5","doc":"","ref":"RabbitMQStream.Connection.html#c:subscribe/5"},{"type":"callback","title":"RabbitMQStream.Connection.unsubscribe/1","doc":"","ref":"RabbitMQStream.Connection.html#c:unsubscribe/1"},{"type":"type","title":"RabbitMQStream.Connection.connection_option/0","doc":"","ref":"RabbitMQStream.Connection.html#t:connection_option/0"},{"type":"type","title":"RabbitMQStream.Connection.connection_options/0","doc":"","ref":"RabbitMQStream.Connection.html#t:connection_options/0"},{"type":"type","title":"RabbitMQStream.Connection.offset/0","doc":"","ref":"RabbitMQStream.Connection.html#t:offset/0"},{"type":"type","title":"RabbitMQStream.Connection.t/0","doc":"","ref":"RabbitMQStream.Connection.html#t:t/0"},{"type":"module","title":"RabbitMQStream.Publisher","doc":"RabbitMQStream.Publisher allows you to define modules or processes that publish messages to a single stream. Defining a publisher Module A standalone publisher module can be defined with: defmodule MyApp.MyPublisher do use RabbitMQStream.Publisher , stream_name : &quot;my-stream&quot; , connection : MyApp.MyConnection end After adding it to your supervision tree, you can publish messages with: MyApp.MyPublisher . publish ( &quot;Hello, world!&quot; ) You can add the publisher to your supervision tree as follows this: def start ( _ , _ ) do children = [ # ... MyApp.MyPublisher ] opts = # ... Supervisor . start_link ( children , opts ) end The standalone publisher starts its own RabbitMQStream.Connection , declaring itself and fetching its most recent publishing_id , and declaring the stream, if it does not exist. Configuration The RabbitMQStream.Publisher accepts the following options: stream_name - The name of the stream to publish to. Required. reference_name - The string which is used by the server to prevent Duplicate Message . Defaults to __MODULE__.Publisher . connection - The identifier for a RabbitMQStream.Connection . You can also declare the configuration in your config.exs : config :rabbitmq_stream , MyApp.MyPublisher , stream_name : &quot;my-stream&quot; , connection : MyApp.MyConnection","ref":"RabbitMQStream.Publisher.html"},{"type":"extras","title":"Getting Started","doc":"","ref":"getting-started.html"},{"type":"extras","title":"Getting Started - Installation","doc":"First add RabbitMQ to your mix.exs dependencies: def deps do [ { :rabbitmq_stream , &quot;~&gt; 0.2.1&quot; } , # ... ] end","ref":"getting-started.html#installation"},{"type":"extras","title":"Getting Started - Subscribing to stream","doc":"First you define a connection defmodule MyApp.MyConnection use RabbitMQStream.Connection end Then you can subscribe to messages from a stream: { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 ) The caller process will start receiving messages with the format {:message, RabbitMQStream.Message.Data.DeliverData} def handle_info ( { :message , RabbitMQStream.Message.Data.DeliverData = message } , state ) do # do something with message { :noreply , state } end","ref":"getting-started.html#subscribing-to-stream"},{"type":"extras","title":"Getting Started - Publishing to stream","doc":"RabbitMQ Streams protocol needs a static :reference_name per publisher. This is used to prevent message duplication. For this reason, each stream needs, for now, a static module to publish messages, which keeps track of its own publishing_id . You can define a Publisher module like this: defmodule MyApp.MyPublisher use RabbitMQStream.Publisher , stream : &quot;stream-01&quot; , connection : MyApp.MyConnection end Then you can publish messages to the stream: MyApp.MyPublisher . publish ( &quot;Hello World&quot; )","ref":"getting-started.html#publishing-to-stream"},{"type":"extras","title":"Subscribing to Messages","doc":"After defining a connection with: defmodule MyApp.MyConnection do use RabbitMQStream.Connection end You can subscribe to messages from a stream with: { :ok , _subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 ) The message will be received with the format {:message, RabbitMQStream.Message.Data.DeliverData} .","ref":"subscribing.html"},{"type":"extras","title":"Subscribing to Messages - Example","doc":"An example GenServer handler that receives messages from a stream could be written like this: defmodule MyApp.MySubscriber do use GenServer alias RabbitMQStream.OsirisChunk def start_link do GenServer . start_link ( __MODULE__ , %{ } ) end def init ( state ) do { :ok , subscription_id } = MyApp.MyConnection . subscribe ( &quot;stream-01&quot; , self ( ) , :next , 999 ) { :ok , Map . put ( state , :subscription_id , subscription_id ) } end def handle_info ( { :message , % OsirisChunk { } = message } , state ) do # do something with message { :noreply , state } end end","ref":"subscribing.html#example"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - 0.1.0","doc":"Initial release with the following features: Opening connection to RabbitMQ server Declaring a Stream Creating a Stream Publisher Subscribing to Stream Messages Initial Hex Release","ref":"changelog.html#0-1-0"},{"type":"extras","title":"Changelog - 0.2.0","doc":"The main objective of this release is to remove the manually added code from rabbitmq_stream_common 's Erlang implementation of Encoding and Decoding logic, with frame buffering.","ref":"changelog.html#0-2-0"},{"type":"extras","title":"Changelog - 0.2.1","doc":"Documentation and Configuration refactoring It is now possible to define the connection and subscriber parameters throught the config.exs file Documentation improvements, and examples","ref":"changelog.html#0-2-1"}]